import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

public abstract class BasicSample {
    protected JFrame frame;
    protected JButton startButton;

    public BasicSample() {
        frame = new JFrame("Timing Sample");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        JPanel panel = new JPanel();
        panel.setLayout(new FlowLayout(FlowLayout.RIGHT));

        startButton = new JButton("Start");
        startButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    JButton button = (JButton)event.getSource();
                    button.setEnabled(false);
                    start();
                }
            });
        panel.add(startButton);

        JButton closeButton = new JButton("Close");
        closeButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    System.exit(0);
                }
            });
        panel.add(closeButton);

        frame.add(panel, BorderLayout.SOUTH);
        frame.setAlwaysOnTop(true);
    }

    protected abstract void start();
    
    protected void clear() {
        startButton.setEnabled(true);
    }
}
