import java.awt.Color;
import java.awt.Font;
import java.awt.Insets;

import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.RepaintManager;
import javax.swing.border.Border;
import javax.swing.border.MatteBorder;

public class CustomLabel extends JLabel {
    private static Font INIT_FONT = new Font("San-Serif", Font.PLAIN, 12);
    private static Border INIT_BORDER 
    = new MatteBorder(new Insets(2, 2, 2, 2), new Color(240, 240, 255));

    public CustomLabel() {
        super();
        setFont(INIT_FONT);
        setBorder(INIT_BORDER);
        RepaintManager.setCurrentManager(new FullRepaintManager());
    }

    public CustomLabel(String text) {
        super(text);
        setFont(INIT_FONT);
        setBorder(INIT_BORDER);
        RepaintManager.setCurrentManager(new FullRepaintManager());
    }

    public CustomLabel(Icon image) {
        super(image);
        setFont(INIT_FONT);
        setBorder(INIT_BORDER);
        RepaintManager.setCurrentManager(new FullRepaintManager());
    }

    public CustomLabel(String text, int horizontalAllignment) {
        super(text, horizontalAllignment);
        setFont(INIT_FONT);
        setBorder(INIT_BORDER);
        RepaintManager.setCurrentManager(new FullRepaintManager());
    }

    public CustomLabel(Icon icon, int horizontalAllignment) {
        super(icon, horizontalAllignment);
        setFont(INIT_FONT);
        setBorder(INIT_BORDER);
        RepaintManager.setCurrentManager(new FullRepaintManager());
    }

    public CustomLabel(String text, Icon icon, int horizontalAllignment) {
        super(text, icon, horizontalAllignment);
        setFont(INIT_FONT);
        setBorder(INIT_BORDER);
        RepaintManager.setCurrentManager(new FullRepaintManager());
    }

    public int getFontSize() {
        return getFont().getSize();
    }

    public void setFontSize(int size) {
        Font font = getFont();
        font = new Font(font.getFamily(), font.getStyle(), size);
        setFont(font);
    }
}
