import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import org.jdesktop.animation.timing.Animator;
import org.jdesktop.animation.timing.TimingTarget;
import org.jdesktop.animation.timing.TimingTargetAdapter;

public class TimingSample3 extends BasicSample {

    private JPanel panel;
    private JButton button;
    private int preX = 50;
    private int preY = 50;

    private Animator animator;

    public TimingSample3() {
        super();

        panel = new JPanel();
        panel.setLayout(null);
        button = new JButton("Click Me :-P");
        button.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    JOptionPane.showMessageDialog(button, "Ouch!");
                }
            });        
        panel.add(button);
        button.setBounds(0, 0, 100, 20);

        JButton pauseButton = new JButton("Pause");
        pauseButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    animator.pause();
                }
            });
        panel.add(pauseButton);
        pauseButton.setBounds(400, 500, 90, 20);

        JButton resumeButton = new JButton("Resume");
        resumeButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    animator.resume();
                }
            });
        panel.add(resumeButton);
        resumeButton.setBounds(500, 500, 90, 20);

        frame.add(panel, BorderLayout.CENTER);
        frame.setSize(new Dimension(600, 600));
        frame.setVisible(true);
    }

    @Override
    protected void start() {
        TimingTarget target = new TimingTargetAdapter() {
                public void end() {
                    clear();
                }

                public void timingEvent(float fraction) {
                    Point point = panel.getMousePosition();
                    if (point == null) {
                        return;
                    }

                    int divX = point.x - preX;
                    int divY = point.y - preY;

                    preX = point.x;
                    preY = point.y;

                    Point p = button.getLocation();
                    button.setLocation(p.x + divX, p.y + divY);
                }
            };

        animator = new Animator(Animator.INFINITE, target);
        animator.start();
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    new TimingSample3();
                }
            });
    }
}
