import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.SwingUtilities;

import org.jdesktop.animation.timing.Animator;
import org.jdesktop.animation.timing.TimingTarget;
import org.jdesktop.animation.timing.TimingTargetAdapter;
import org.jdesktop.animation.timing.interpolation.PropertySetter;

public class TimingSample6 extends BasicSample {

    private CustomLabel label;

    private Animator animator;

    public TimingSample6() {
        super();

        label = new CustomLabel("Property Change!");

        frame.add(label, BorderLayout.CENTER);
        frame.setSize(new Dimension(400, 140));
        frame.setVisible(true);
        
        setAnimator();
    }

    private void setAnimator() {
        int orig1 = label.getFontSize();
        animator = PropertySetter.createAnimator(5000, label, "fontSize", 
                                                 orig1, 48);

        TimingTarget target = new TimingTargetAdapter() {
                public void end() {
                    clear();
                }
            };
        animator.addTarget(target);
    }

    @Override
    protected void start() {
        animator.start();
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    new TimingSample6();
                }
            });
    }
}
